SystemOrganization addCategory: #'Glamour-Tools'!
SystemOrganization addCategory: 'Glamour-Tools-Tests'!

TestCase subclass: #GLMBrowserVisualisationTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools-Tests'!

!GLMBrowserVisualisationTest methodsFor: 'running' stamp: 'JurajKubelka 5/28/2013 13:14'!
tearDown

	window ifNotNil: [ :w | w delete. window := nil ].
	super tearDown.! !

!GLMBrowserVisualisationTest methodsFor: 'tests' stamp: 'JurajKubelka 5/28/2013 12:05'!
testViewTree

	self shouldnt: [ window := GLMBrowser new viewTree ] raise: Error! !

!GLMCompositePresentation methodsFor: '*Glamour-Tools' stamp: 'TudorGirba 10/24/2014 06:53'!
viewTreeOn: view
	| b label line elements |

	b := RTUMLClassBuilder new.
	b
		addObjects: self pane withAllPanes;
		classname: #name;
		instanceVariables: nil;
		methodsNames: #ports;
		methodselector: #name;
		attributeselector: nil;
		buildSchema: view.
	elements := RTGroup new.
	elements addAll: b classesGroup.
	
	label := RTLabel new height: 10; text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	
	self pane withAllPresentations do: [ :p | | e |
		view add: (e:= (label elementOn: p ) @ RTDraggable).
		elements add: e ].
	
	line := RTMultiLine new orthoVertical attachPoint: RTVerticalAttachPoint instance.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #yourself to: [ :each | each presentations ] using: line inView: view.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #browser to: #yourself using: line inView: view.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation])
		from: #yourself to: #cachedPresentation using: line inView: view scope: elements.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation])
		from: #yourself toAll: #presentations using: line inView: view scope: elements.
		
	RTTreeLayout new on: elements.
	
	line := RTLine new color: Color blue; attachPoint: RTShorterDistanceAttachPoint instance.
	RTEdge buildEdgesFromObjects: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		from: #destination toAll: #origins using: line inView: view.
	! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'JurajKubelka 5/27/2013 16:27'!
openTree
	| composer |
	composer := GLMCompositePresentation new.
	composer 
		act: [:b | b update] 
		icon: GLMUIThemeExtraIcons glamorousRefresh 
		entitled: 'Update'.
	composer tabulator with: [:t | 
		t column: #theOne.
		t transmit to: #theOne; andShow: [:a | 
			a roassal 
				updateOn: GLMTransmissionTriggered from: [ self announcer ];
				painting: [:view :b | self viewTreeOn: view ] ]].
	composer openOn: self! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'tg 5/18/2010 13:50'!
screenshot: aFilenameString on: anObject after: aBlock
	 
	| window |
	window := self openOn: anObject.
	aBlock glamourValue: self asGlamorousMultiValue.
	World doOneCycle.
	PNGReadWriter putForm: window imageForm onFileNamed: aFilenameString.
	^ window! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 10/24/2014 22:42'!
viewAnnouncementsOn: view
	"view shape rectangle withoutBorder.
	view node: 'Glamour' forIt: [
		self viewTreeOn: view ].
	self umlClassWithTitle: #yourself view: view nodes: (Array with: 'Announced objects') forEach: [ :eachNode |
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPanes flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asSet.
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPresentations flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asIdentitySet.
		view verticalLineLayout ].
	
	view shape line 
			color: Color red twiceLighter;
			attachPoint: (ROHorizontalAttachPoint new).
	view edges: self pane withAllPanes from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view shape line 
			color: Color red twiceLighter;
			attachPoint: (ROHorizontalAttachPoint new).
	view edges: self pane withAllPresentations from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view horizontalLineLayout horizontalGap: 50"! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'akevalion 10/23/2014 15:29'!
viewTree

	| view |
	view := RTView new.
	view @ RTDraggableView.
	self viewTreeOn: view.
	^ view open.! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'akevalion 10/23/2014 16:49'!
viewTreeOn: view
	| b label line elements |

	b := RTUMLClassBuilder new.
	b
		addObjects: self pane withAllPanes;
		classname: #name;
		instanceVariables: nil;
		methodsNames: #ports;
		methodselector: #name;
		attributeselector: nil;
		buildSchema: view.
	elements := RTGroup new.
	elements addAll: b classesGroup.
	
	label := RTLabel new height: 10; text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	
	self pane withAllPresentations do: [ :p | | e |
		view add: (e:= (label elementOn: p ) @ RTDraggable).
		elements add: e ].
	
	line := RTMultiLine new orthoVertical attachPoint: RTVerticalAttachPoint instance.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #yourself to: [ :each | each presentations ] using: line inView: view.
	
	RTEdge buildEdgesFromObjects: self pane withAllPanes 
		from: #browser to: #yourself using: line inView: view.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation])
		from: #yourself to: #cachedPresentation using: line inView: view scope: elements.
		
	RTEdge buildEdgesFromObjects: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation])
		from: #yourself toAll: #presentations using: line inView: view scope: elements.
		
	RTTreeLayout new on: elements.
	
	line := RTLine new color: Color blue; attachPoint: RTShorterDistanceAttachPoint instance.
	RTEdge buildEdgesFromObjects: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		from: #destination toAll: #origins using: line inView: view.
	! !

Object subclass: #GLMBrowserTemplate
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMBrowserTemplate class methodsFor: 'opening' stamp: 'tg 12/29/2009 03:33'!
openOn: anEntity
	^ self new openOn: anEntity! !

!GLMBrowserTemplate class methodsFor: 'opening' stamp: 'tg 1/15/2010 23:46'!
startOn: anEntity
	^ self new startOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'accessing' stamp: 'tg 12/29/2009 03:41'!
browser
	^ browser ifNil: [self buildBrowser. browser]! !

!GLMBrowserTemplate methodsFor: 'building' stamp: 'tg 12/15/2009 13:54'!
buildBrowser
	^ self subclassResponsibility! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:30'!
openOn: anEntity
	^ self browser openOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 1/15/2010 23:31'!
startOn: anEntity
	^ self browser startOn: anEntity! !

GLMBrowserTemplate subclass: #GLMGlobalBrowserTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMGlobalBrowserTemplate class methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self new
		open! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
entity
	^ self subclassResponsibility! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self openOn: self entity! !

GLMBrowserTemplate subclass: #GLMScriptingEditorTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMScriptingEditorTemplate commentStamp: 'TudorGirba 12/28/2011 23:33' prior: 0!
GLMScriptingEditorTemplate offers a simple template for building scripting editors.

It offers basically three panes:
- one for the script
- one for the set of input variables
- one for the preview once you accept the script

A typical case is provided by the GLMMondrianEasel.

To open any of the subclasses, you need to provide an array of associations whose values represent the names of a variables and the values are the objects referred by these variables. These variables can then be used in the code of the script.!

GLMScriptingEditorTemplate subclass: #GLMEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMEditor commentStamp: 'TudorGirba 12/28/2011 23:33' prior: 0!
This is an Glamour-based editor for Glamour browsers.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMEditor methodsFor: 'private' stamp: 'TudorGirba 12/30/2013 07:59'!
createResultBrowserWithBindings: bindings andScript: script
	| context resultBrowser scriptedBrowser composer |
	composer := GLMCompositePresentation new.
	context := GLMDoItContext with: #composer -> composer withAll: bindings.
	[ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			self inform: e class name , ': ' , e messageText halt. 
			^ GLMWrapper new show: #text; startOn: e class name , ': ' , e messageText ].
	scriptedBrowser := composer first.
	resultBrowser := GLMTabulator new.
	resultBrowser column: #theOuterPane.
	resultBrowser transmit
		fromOutsideEntityPort;
		to: #theOuterPane;
		andShow: [ :a | a custom: scriptedBrowser ].	"this is a bit of a hack.
	we take the entity as specified in the script by taking it directly
	from the evaluated script browser.
	this is needed because right now the input entity is specified 
	in the same script with the browser"
	^ resultBrowser startOn: composer entity! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	^ {#composer -> GLMCompositePresentation new}! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 6/1/2012 20:13'!
defaultScriptDisplayIn: aTextPresentation
	^ aTextPresentation 
		display: 'composer';
		morphicAct: [:text | GLMBasicExamples open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 12/8/2012 14:30'!
defaultTitle
	^ 'Glamour Editor'! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 5/24/2012 17:20'!
resultIn: composite
	composite dynamic
		title: 'Preview';
		display: [ :bindings :script | self createResultBrowserWithBindings: bindings andScript: script ];
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first openTree ] 
			entitled: 'View browser tree';
		act: [:dynamic | dynamic cachedPresentation presentations first panes first presentations first explore ]
			icon: GLMUIThemeExtraIcons glamorousInspect
			entitled: 'Explore';
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first open ] 
			icon: GLMUIThemeExtraIcons glamorousSpawn
			entitled: 'Spawn browser'! !

!GLMScriptingEditorTemplate class methodsFor: 'instance creation' stamp: 'TudorGirba 6/1/2012 20:09'!
open
	^ self openOn: {}! !

!GLMScriptingEditorTemplate class methodsFor: 'instance creation' stamp: 'TudorGirba 1/4/2012 08:08'!
openOn: anArrayOfAssociations
	"To spawn an editor, provide an array of associations whose values represent the names of a variables and the values are the objects referred by these variables. These variables can then be used in the code of the script.
	For example: 
	GLMEditor openOn: {#variable1->'value1' . #variable2->'value2'}"
	^ super openOn: anArrayOfAssociations! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:05'!
buildBrowser
	browser := GLMTabulator new.
	self setTitleOf: browser.
	browser
		row: #result span: 2;
		row: [ :r | 
					r
						column: #script span: 3;
						column: #variables span: 2 ].
	browser transmit
		to: #script;
		andShow: [ :a | self scriptIn: a ].
	browser transmit
		to: #variables;
		andShow: [ :a | self variablesIn: a ].
	browser transmit
		to: #result;
		fromOutsidePort: #entity;
		from: #script;
		andShow: [ :a | self resultIn: a ].
	^ browser! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	"Override this method if you want to provide more bindings for your editor.
	Typically these bindings are related to the Facade that offers the entry point to the scripting API"
	^ {}! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptDisplayIn: aPresentation
	^ ''! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:06'!
defaultTitle
	^ 'Editor'! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 18:55'!
resultIn: a
	"Override this method to describe the presentation that should show the result
	of evaluating the script"
	self subclassResponsibility ! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 5/24/2012 18:16'!
scriptIn: a
	^ a smalltalkCode
		title: 'Script';
		variableBindings: [ :bindings | 
					| col |
					col := OrderedCollection withAll: bindings.
					col addAll: self defaultScriptBindings.
					col ];
		with: [:p | self defaultScriptDisplayIn: p ];
		populate: #selection
			icon: GLMUIThemeExtraIcons glamorousPlay
			on: $s
			entitled: 'Generate'
			with: [ :text | text text ]
	";	act: [:text | text text ] icon: GLMUIThemeExtraIcons glamorousAccept entitled: 'Install'"! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:05'!
setTitleOf:  b
	b title: self defaultTitle! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 11/15/2011 21:44'!
variablesIn: a
	^ a table
		selectionAct: [:t | t selection value inspect ] on: $i entitled: 'Inspect';
		selectionAct: [:t | t selection value explore ] on: $I entitled: 'Explore';		
		column: 'Variable' evaluated: [ :each | each key asString ];
		column: 'Value' evaluated: [ :each | each value asString contractTo: 20 ]! !

Object subclass: #GLMDoItContext
	instanceVariableNames: 'variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMDoItContext commentStamp: 'TudorGirba 8/24/2011 23:50' prior: 0!
This offers support for a do it context.

Example:
context := GLMContext withAll: {#a -> 1 . #b -> 2}.
Compiler new evaluate: 'a + b' in: context to: context!

!GLMDoItContext class methodsFor: 'instance creation' stamp: 'TudorGirba 8/25/2011 00:03'!
with: aBinding withAll: aCollectionOfBindings
	| col |
	col := OrderedCollection with: aBinding.
	col addAll: aCollectionOfBindings.
	^ self withAll: col! !

!GLMDoItContext class methodsFor: 'instance creation' stamp: 'TudorGirba 8/24/2011 23:48'!
withAll: aCollectionOfBindings
	^ self new variableBindings: (aCollectionOfBindings inject: Dictionary new into: [:dict :each | dict at: each key put: each value. dict])! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:36'!
bindingOf: aKey
	^ self variableBindings at: #aKey ifAbsent: [nil]! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 3/15/2013 21:27'!
method 
	^ GLMDoItContext >> #method! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:44'!
namedTempAt: index
	^ self variableBindings at: (self tempNames at: index)! !

!GLMDoItContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:43'!
tempNames
	^ self variableBindings keys asSortedCollection! !

!GLMDoItContext methodsFor: 'accessing' stamp: 'TudorGirba 8/24/2011 23:36'!
variableBindings
	^ variableBindings! !

!GLMDoItContext methodsFor: 'accessing' stamp: 'TudorGirba 8/24/2011 23:36'!
variableBindings: anObject
	variableBindings := anObject! !
